#pragma once

#define void_proc_c typedef void (__cdecl *zProc)
#define long_proc_c typedef long (__cdecl *zProc)
#define short_proc typedef short (__stdcall *zProc)
#define long_proc typedef long (__stdcall *zProc)
#define char_proc typedef char* (__stdcall *zProc)
#define wchar_proc typedef WCHAR* (__stdcall *zProc)
#define strSize(s) ( sizeof(s) / sizeof(s[0]) )
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16))
#define strSize(s) ( sizeof(s) / sizeof(s[0]) )
#define UBOUND(T) (T.size())

long zTrace(IN WCHAR* sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) {
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64");
        }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc(WCHAR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hDll, "zTrace"); }
        if (hProc) { nRet = hProc(sPtr); }
    }
    return nRet;
}

//extern "C" void* __cdecl memmove(void* dst, void const* src, size_t n) {
//    void* ret = dst;
//
//    if (dst != nullptr && src != nullptr) {
//        if (dst <= src || (char*) dst >= ((char*) src + n)) {
//            // Non-overlapping buffers; copy from lower addresses to higher addresses
//            while (n--) {
//                *(char*) dst = *(char*) src;
//                dst = (char*) dst + 1;
//                src = (char*) src + 1;
//            }
//        } else {
//            // Overlapping buffers; copy from higher addresses to lower addresses
//            dst = (char*) dst + n - 1;
//            src = (char*) src + n - 1;
//            while (n--) {
//                *(char*) dst = *(char*) src;
//                dst = (char*) dst - 1;
//                src = (char*) src - 1;
//            }
//        }
//    } else {
//        ret = nullptr;
//    }
//    
//    return ret;
//}

long rWidth(IN RECT &r){
    return r.right - r.left;
}

long rHeight(IN RECT &r) {
    return r.bottom - r.top;
}

WCHAR* EXEpath() {
    static WCHAR exepath[MAX_PATH] = { 0 };
    if (GetModuleFileName(0, exepath, MAX_PATH)) {
        long nLen = (long)wcslen(exepath);
        long nPos = nLen;
        for (long K = 1; K <= nLen; K++) {
            if (_wcsicmp(&exepath[nPos - K], L"\\") != 0) { exepath[nPos - K] = NULL; }
            else { break; }
        }
    }
    return exepath;
}

void ClearMemory(IN void* mem, IN long nSize) {
    __stosb((PBYTE) mem, (BYTE) 0, (SIZE_T) nSize);
}

WCHAR* Path_Combine(OUT WCHAR* zResource, IN WCHAR* path, IN WCHAR* combine) {
    // This version try to protect from buffer overflow
    long nLenPath = lstrlenW(path), nLenCombine = lstrlenW(combine);
    ClearMemory(zResource, MAX_PATH * sizeof(WCHAR));
    if (nLenPath < MAX_PATH) {
        MoveMemory(zResource, path, nLenPath * sizeof(WCHAR));
        if (nLenPath + nLenCombine < MAX_PATH) {
            MoveMemory(&zResource[nLenPath], &combine[0], nLenCombine * sizeof(WCHAR));
        }
    }
    return zResource;
}

WCHAR* EXEresource() {
    static WCHAR zpath[MAX_PATH];
    static long done;
    if (done == 0) {
        ClearMemory(zpath, sizeof(zpath));
        Path_Combine(zpath, EXEpath(), (WCHAR*) L"Resource\\");
        done = -1;
    }
    return zpath;
}

WCHAR* Resource(IN WCHAR* sFile) {
    static WCHAR zpath[MAX_PATH];
    ClearMemory(zpath, sizeof(zpath));
    Path_Combine(zpath, EXEresource(), sFile);
    return zpath;
}

BOOL FileExist(IN WCHAR* szFileSpec) {
    DWORD dwAttr = GetFileAttributesW(szFileSpec);
    return ((dwAttr != INVALID_FILE_ATTRIBUTES) && !(dwAttr & FILE_ATTRIBUTE_DIRECTORY));
}

//void* my_memmove(void* dst, const void* src, size_t n) {
//    unsigned char* d = (unsigned char*) dst;
//    const unsigned char* s = (const unsigned char*) src;
//    void* ret = dst;
//
//    if (dst != NULL && src != NULL) {
//        if (d < s || d >= (s + n)) {
//            // Non-overlapping buffers; copy from lower addresses to higher addresses
//            while (n--) {
//                *d++ = *s++;
//            }
//        } else {
//            // Overlapping buffers; copy from higher addresses to lower addresses
//            d += n;
//            s += n;
//            while (n--) {
//                *(--d) = *(--s);
//            }
//        }
//    } else {
//        ret = NULL;
//    }
//
//    return ret;
//}

WCHAR* safecopy(IN WCHAR* dst, IN const WCHAR* src, IN long dstSize = MAX_PATH) {
    long nLen = lstrlenW(src);

    // rather than wcscopy, this version protect against buffer overflow !
    nLen = min(max(dstSize - 1, 0), nLen); if (nLen == 0) return NULL;

    memmove(dst, src, nLen * sizeof(WCHAR));
    dst[nLen] = L'\0';
    return dst;
}

long CheckStyle(IN long nMainStyle, IN long nStyleToCheck) {
    long nRet = 0;
    if ((nMainStyle & nStyleToCheck) == nStyleToCheck) { nRet = -1; }
    return nRet;
}

LRESULT List_Add(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (hList) {
       if (wcslen(zTmp)) { nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp); }
    }
    return nIndex;
}

void List_DeleteAll(IN HWND hList) {
    if (hList) { SendMessage(hList, LB_RESETCONTENT, 0, 0); }
}

long List_FindString(IN HWND hList, IN WCHAR* zTmp) {
    long nIndex = 0;
    if (IsWindow(hList)) {
        nIndex = (long) SendMessage(hList, LB_FINDSTRING, -1, (LPARAM) zTmp);
        if (nIndex > -1) { ++nIndex; }
    }
    return nIndex;
}

long List_GetCount(IN HWND hList) {
    long nRet = 0;
    if (IsWindow(hList)) { nRet = (long) SendMessage(hList, LB_GETCOUNT, 0, 0); }
    return nRet;
}

long List_GetCursel(IN HWND hList) {
    long nIndex = 0;
    if (hList) {
       nIndex = (long) SendMessage(hList, LB_GETCURSEL, 0, 0);
       if (nIndex > -1) { ++nIndex; } // Because ListBox is zero based
    }
    return nIndex;
}

WCHAR* List_GetText (IN HWND hList, IN long nItem) {
    static WCHAR szData[MAX_PATH];
    memset(szData, 0, sizeof(WCHAR));
    if (nItem > 0) {
        --nItem; SendMessage(hList, LB_GETTEXT, nItem, (LPARAM) szData);
    }
    return szData;
}

void List_SelectPlus(IN HWND hList, IN long nIndex) {
    if (nIndex < 0) { hList = 0; }
    if (hList) {
        if (nIndex > 0) { --nIndex; } // Because ListBox is zero based
        SendMessage(hList, LB_SETCURSEL, nIndex, 0); 
    }
}

float sqrt_float(BYTE number) {
    if (number == 0) return 0;

    float x = number;
    float root;
    const int max_iterations = 20; // Number of iterations for convergence
    for (int i = 0; i < max_iterations; i++) {
        root = 0.5f * (x + number / x);
        x = root;
    }
    return root;
}
